# SpreadsheetDoc - Document Your Spreadsheets

Documentation is an important artifact of any software product. 
For once, users documentation is important so they can be more productive, 
without the need to arbitrarily looking for the feature they want, or the need to ask a colleague. On the other hand, developer documentation allows for software professionals to more easily maintain the software.

This problem is even worst when dealing with software for non-professional programmers. In fact, in many cases such documentation is not even available. For instance, for spreadsheets, and even considering an industrial setting, only 30% have some kind of documentation. This makes their usage and maintenance very difficult.

SpreadsheetDoc is an Excel add-in that allows users to document spreadsheets in a structured way, allowing them to describe different parts of spreadsheets. For instance, for (future) spreadsheet users, it is possible to describe input and output cells, and for (future) developers, it is possible to describe computation, that is, formulas: their argument, their internals, and their outputs.

The following scientific paper describes in more detail SpreadsheetDoc: http://docentes.fct.unl.pt/jmc-cunha/publications/spreadsheetdoc-excel-add-documenting-spreadsheets.
